#define MaxBuffer 32
volatile unsigned char buffer[MaxBuffer];   
volatile unsigned  char * p1;
char Texte[64];
char *txt;
unsigned short error;
volatile unsigned int CptErr;

volatile unsigned int i1;
volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;
volatile int Flag_Buffer;
volatile int Index1;
volatile  unsigned char c1,c2;



void interrupt(void)  org 0x04
{
  if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      Flag_Buffer=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer[i1]=c1;
        Index1=i1;
        i1++;
        if (i1>=MaxBuffer) i1=0;
      }
   }
}


void putch(unsigned char d)
{
    while (!TXIF) ;          // wait until TXREG empty
    TXREG = d;           // send character
}


void CRLF()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
}


void Init_Hardware()
{

 PORTA=0;
 PORTB=0;
 ANSELA = 0;        //Set PORTA  digital  I/O
 TRISA=0b11101111; // RA4 as output

 ANSELB = 0;         //Set PORTB as digital I/O
 TRISB=0b11101111;  // all input   excpet RB4

 APFCON0=0;  // ALTERNATE PIN FUNCTION CONTROL REGISTER 0// page 119
 APFCON0.RXDTSEL=0;
 // RXDTSEL=0  RX/DT function is on RB1
 // SDO1SEL=0  SDO1 function is on RB2
 // SS1SEL =0  SS1 function is on RB5
 // P2BSEL =0  P2B function is on RB7
 // CCP2SEL =0 CCP2/P2A function is on RB6
 // P1DSEL= 0  P1D function is on RB7
 // P1CSEL= 0  P1C function is on RB6
 // CCP1SEL= 0 CCP1/P1A function is on RB3
 APFCON1=0; // ALTERNATE PIN FUNCTION CONTROL REGISTER 1
 APFCON1.TXCKSEL=0; //  TX/CK function is on RB2

 CM1CON0=0;       // disable comparators
 CM1CON1=0;
 FVRCON.FVREN=0;  // disble fixed voltage reference
 EECON1.EEPGD=0;  // is the control register for EE memorya Accesses.
 // Option REG
 //  WPUEN INTEDG TMR0CS TMR0SE PSA PS<2:0>
 OPTION_REG=0;
 OPTION_REG.WUE=0;  // // WPUEN=0 enable all pull up
 WPUB=0xFF;
 //INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF
 INTCON.PEIE=0;
 // PIE1
 //TMR1GIE ADIE RCIE TXIE SSP1IE CCP1IE TMR2IE TMR1IE
 PIE1=0;  // deja a zero sur reset
 // PIR1: PERIPHERAL INTERRUPT REQUEST REGISTER 1
 // TMR1GIF ADIF RCIF TXIF SSP1IF CCP1IF TMR2IF TMR1IF
 PIR1=0;    // deja a zero sur reset
 //   INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF p89
 INTCON.IOCIE=0;  // disable interrupt PORTB
 INTCON.GIE=0;
 }
 

void Raz_UART_Buffer()
{
  int i;
  Flag_Buffer=0;
  for (i=0;i<31;i++) buffer[i]=0;
  Index1=0;
  c1=RCREG;  // efface flag RCIF si lev
  c1=0;
  p1=buffer;
 }



void main() 
{
  OSCCON = 0b01111010;     // 16 MHz 4 bits
  Init_Hardware();
  Delay_ms(100);
 // init pointeur zones textes
  txt=&Texte[0];
  p1=&buffer[0];

  UART1_Init(19200);
  UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle); // set UART1 active
  while(PIR1.RCIF==1) c1 = RCREG;
  UART1_Write(CLS);
  Delay_ms(1000);
 
  Raz_UART_Buffer();
  strConstRamCpy(txt, mesg0);
  UART1_Write_Text(txt) ;
  strConstRamCpy(txt, mesg1);
  UART1_Write_Text(txt) ;

while(1)
 {
   if ( Flag_Buffer==1)
   {
     UART1_Write_CText("Reception de : ");
     UART1_Write_Text(buffer); CRLF();
     Raz_UART_Buffer();
     PIE1.RCIE=1;
   }
 }
}


